/*
      ____                      _____                  +---+
     / ___\                     / __ \                 | R |
    / /                        / /_/ /                 +---+
   / /   ________  ____  ___  / ____/___  ____  __   __
  / /  / ___/ __ `/_  / / _ \/ /   / __ \/ _  \/ /  / /
 / /__/ /  / /_/ / / /_/  __/ /   / /_/ / / / / /__/ /
 \___/_/   \__,_/ /___/\___/_/    \___ /_/ /_/____  /
                                                 / /
                                            ____/ /
                                           /_____/
main.c file
编写者：小马  (Camel)
作者E-mail：375836945@qq.com
编译环境：MDK-Lite  Version: 4.23
初版时间: 2014-01-28
功能：
------------------------------------
*/
#include "config.h"             //包含所有的驱动头文件
#include "stm32f10x.h"

enum
{
	TX,
	RX
};

uint8_t buf[32];
uint8_t rtFlag = TX;//初始化为无线模块模式
uint8_t rtModeFlag = 0; //1 == r , 0 == t

int main(void)
{
	/***********************************/
	SystemClock_HSI(9);           //系统时钟初始化，时钟源内部HSI
	cycleCounterInit();				    // Init cycle counter
	SysTick_Config(SystemCoreClock / 1000);	//SysTick开启系统tick定时器并初始化其中断，1ms
	UART1_init(SysClock,uart1baudSet); //串口1初始化
  NVIC_INIT();	                //中断初始化
  STMFLASH_Unlock();            //内部flash解锁
  LoadParamsFromEEPROM();				//加载系统参数配置表
  LedInit();	                  //IO初始化
  Adc_Init();										//摇杆AD初始化
	KeyInit();										//按键初始化
 	NRF24L01_INIT();              //NRF24L01初始化
  SetTX_Mode();                 //设无线模块模式

	TIM4_Init(SysClock,TIME4_Preiod);	  //定时器4初始化，定时时间单位：(TIME4_Preiod)微秒
	
	LoadRCdata();                //摇杆赋值
	 
  while (1)             
	{ 
//		//10Hz loop
		if(flag10Hz == 1)  //10Hz 
		{		

			flag10Hz = 0;
			checkKey();
			lowVoltageBeep();
		}

		//50Hz loop
		if(flag50Hz == 1)
		{
			cmdReduce();
			if(!(remoteData.cmd & NEWADDRESS))
			{
				rtModeFlag = 0;
				if(rtFlag != RX)
				{
					rtFlag = RX;
					SetRX_Mode();
				}
				printf("{\"roll\":\"%d\",\"pitch\":\"%d\",\"yaw\":\"%d\",\"key\":\"%d\",\"voltage\":\"%d\",\"rollStick\":\"%d\",\"pitchStick\":\"%d\",\"thrStick\":\"%d\",\"yawStick\":\"%d\",\"RVFV\":\"%d%d\"}",
							flightData.rollAngle,flightData.pitchAngle,flightData.yawAngle,remoteData.key,flightData.voltage,(remoteData.motor[ROLL]-1000)/4,(remoteData.motor[PITCH]-1000)/4,(remoteData.motor[THROTTLE]-1000)/4,
							(remoteData.motor[YAW]-1000)/4,VERSION_RC,flightData.version);
				Nrf_Irq();
				
			}
			flag50Hz = 0;
		}
		
		// 80Hz 12.5ms
		if(flag80Hz)
		{				
			flag80Hz = 0;
			powerOn();
						
		}
		if(flag100Hz)
		{
						
			if(rtFlag != TX)
			{
				rtFlag = TX;
				SetTX_Mode();
			}
			if(remoteData.cmd & NEWADDRESS)
			{
				modifyAddress();
				
			}
			sendF3Data();
			
		}
//		if(remoteData.cmd & NEWADDRESS)
//		{
//			modifyAddress();
//			sendF3Data();
//		}
//		else
//		{
//			static int count = 0;
//			count++;
//			if(count>7)
//			{
//				count = 0;
//			}
//			if(rtFlag)
//			{
//				printf("read time:%d\r\n",micros());
//				Nrf_Irq();
//				if(count > 2)
//				{
//					if(rtModeFlag == 0)
//					{
//						SetTX_Mode();
//						rtModeFlag = 1;
//					}
//					rtFlag = 0;
//				}
//			}
//			else
//			{
//				printf("send time:%d\r\n",micros());
//				sendF3Data();
//				if(count < 3)
//				{
//					if(rtModeFlag)
//					{
//						SetRX_Mode();
//						rtModeFlag = 0;
//					}
//					rtFlag = 1;
//				}
//			}
//		}
		//sendF3Data();
	}
}

